// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <goocanvasmm/group.h>
#include <goocanvasmm/private/group_p.h>


/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasgroup.h>


namespace Goocanvas
{

} //namspace GooCanvas


namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Goocanvas::Group> wrap(GooCanvasGroup* object, bool take_copy)
{
  return Glib::RefPtr<Goocanvas::Group>( dynamic_cast<Goocanvas::Group*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Goocanvas
{


/* The *_Class implementation: */

const Glib::Class& Group_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Group_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(goo_canvas_group_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void Group_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* Group_Class::wrap_new(GObject* object)
{
  return new Group((GooCanvasGroup*)object);
}


/* The implementation: */

GooCanvasGroup* Group::gobj_copy()
{
  reference();
  return gobj();
}

Group::Group(const Glib::ConstructParams& construct_params)
:
  Goocanvas::ItemSimple(construct_params)
{

}

Group::Group(GooCanvasGroup* castitem)
:
  Goocanvas::ItemSimple((GooCanvasItemSimple*)(castitem))
{}


Group::Group(Group&& src) noexcept
: Goocanvas::ItemSimple(std::move(src))
{}

Group& Group::operator=(Group&& src) noexcept
{
  Goocanvas::ItemSimple::operator=(std::move(src));
  return *this;
}

Group::~Group() noexcept
{}


Group::CppClassType Group::group_class_; // initialize static member

GType Group::get_type()
{
  return group_class_.init().get_type();
}


GType Group::get_base_type()
{
  return goo_canvas_group_get_type();
}


Group::Group()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemSimple(Glib::ConstructParams(group_class_.init()))
{
  

}

Glib::RefPtr<Group> Group::create()
{
  return Glib::RefPtr<Group>( new Group() );
}


} // namespace Goocanvas


